[project]
name = "lang-main"
version = "0.1.0dev1"
description = "Several tools to analyse maintenance data with strong focus on language processing"
authors = [
    {name = "d-opt GmbH, resp. Florian Förster", email = "f.foerster@d-opt.com"},
]
dependencies = [
    "pandas>=2.2.2",
    "networkx>=3.3",
    "spacy>=3.7.4",
    "sentence-transformers[onnx]>=3.2.0",
    "numpy>=1.26.4",
    "pip>=24.0",
    "typing-extensions>=4.12.2",
    "tqdm>=4.67.0",
    "python-dateutil>=2.9.0.post0",
    "onnx==1.16.1",
]
requires-python = ">=3.11"
readme = "README.md"
license = {text = "LicenseRef-Proprietary"}

[project.optional-dependencies]
dash = [
    "dash-cytoscape>=1.0.2",
    "dash>=2.18.2",
    "kaleido==0.2.1",
]
plot = [
    "kaleido==0.2.1",
    "plotly>=5.24.1",
]
cytoscape = [
    "py4cytoscape>=1.11.0",
]
spacy-trf = [
    "de-dep-news-trf @ https://github.com/explosion/spacy-models/releases/download/de_dep_news_trf-3.8.0/de_dep_news_trf-3.8.0-py3-none-any.whl",
]
spacy-sm = [
    "de-core-news-sm @ https://github.com/explosion/spacy-models/releases/download/de_core_news_sm-3.8.0/de_core_news_sm-3.8.0-py3-none-any.whl",
]
spacy-md = [
    "de-core-news-md @ https://github.com/explosion/spacy-models/releases/download/de_core_news_md-3.8.0/de_core_news_md-3.8.0-py3-none-any.whl",
]
spacy-lg = [
    "de-core-news-lg @ https://github.com/explosion/spacy-models/releases/download/de_core_news_lg-3.8.0/de_core_news_lg-3.8.0-py3-none-any.whl",
]
[build-system]
requires = ["pdm-backend"]
build-backend = "pdm.backend"


[tool.pdm]
distribution = true

[tool.pdm.dev-dependencies]
notebooks = [
    "jupyterlab>=4.2.0",
    "ipywidgets>=8.1.2",
]
# Alph relies on Pygraphviz which again relies on Graphviz, to sucessfully build
# Pygraphviz the MSVC toolchain should be installed on the target system if it is Windows
# (Linux not tested yet). The compiler needs additional information about the location of Graphviz
# files. This information is provided by extra options.
# --config-setting="--global-option=build_ext" --config-setting="--global-option=-IC:\Program Files\Graphviz\include" --config-setting="--global-option=-LC:\Program Files\Graphviz\lib"
trials = [
]
dev = [
    "cython>=3.0.10",
    "openpyxl>=3.1.5",
    "seaborn>=0.13.2",
    "pytest>=8.3.3",
    "pytest-cov>=6.0.0",
]

[tool.ruff]
line-length = 94
indent-width = 4
target-version = "py311"
src = ["src"]

[tool.ruff.format]
quote-style = "single"
skip-magic-trailing-comma = false

[tool.ruff.lint]
select = ["E", "F", "I"]

[tool.ruff.lint.isort]
extra-standard-library = ["typing_extensions"]

[tool.pytest.ini_options]
addopts = [
    "-vvl",
    "--import-mode=importlib",
]
testpaths = [
    "tests",
]
filterwarnings = [
    'ignore:pkg_resources is deprecated as an API.:DeprecationWarning'
]
markers = [
    "mload: marks tests with loading of language models (deselect with '-m \"not mload\"')",
]
log_cli = true

[tool.coverage.run]
relative_files = true
source = [
    "lang_main",
    "tests/",
]

[tool.coverage.report]
exclude_also = [
    "def __repr__",
    "def __str__",
    "@overload",
    "if logging",
    "if TYPE_CHECKING",
]

[tool.coverage.html]
directory = "reports/coverage"